(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('prop-types'), require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'prop-types', 'react'], factory) :
  (factory((global.index = {}),global.PropTypes,global.React));
}(this, (function (exports,PropTypes,React) { 'use strict';

  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
  React = React && React.hasOwnProperty('default') ? React['default'] : React;

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectSpread(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};
      var ownKeys = Object.keys(source);

      if (typeof Object.getOwnPropertySymbols === 'function') {
        ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
          return Object.getOwnPropertyDescriptor(source, sym).enumerable;
        }));
      }

      ownKeys.forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    }

    return target;
  }

  function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    subClass.__proto__ = superClass;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  var _isPromise_2_1_0_isPromise = isPromise;

  function isPromise(obj) {
    return !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function';
  }

  var some = function some(arr, pred) {
    arr = arr || [];

    for (var i = 0; i < arr.length; ++i) {
      if (pred && pred(arr[i])) {
        return true;
      }
    }

    return false;
  };
  var toPairs = function toPairs(obj) {
    return obj ? Object.keys(obj).map(function (k) {
      return [k, obj[k]];
    }) : [];
  };
  var fromPairs = function fromPairs(arr) {
    var ret = {};
    (arr || []).forEach(function (_ref) {
      var k = _ref[0],
          v = _ref[1];
      return ret[k] = v;
    });
    return ret;
  };
  var mapValues = function mapValues(obj, mapper, filter) {
    if (mapper === void 0) {
      mapper = function mapper(v) {
        return v;
      };
    }

    if (filter === void 0) {
      filter = function filter() {
        return true;
      };
    }

    return fromPairs(toPairs(obj).filter(function (_ref2) {
      var k = _ref2[0],
          v = _ref2[1];
      return filter(v, k);
    }).map(function (_ref3) {
      var k = _ref3[0],
          v = _ref3[1];
      return [k, mapper(v, k)];
    }));
  };
  var isFunction = function isFunction(func) {
    return typeof func === 'function';
  };

  var isStateless = function isStateless(Component) {
    return !Component.prototype || !Component.prototype.render;
  };

  var DefaultLoadingComponent = function DefaultLoadingComponent() {
    return null;
  };
  var DefaultErrorComponent = function DefaultErrorComponent() {
    return null;
  };
  var SymbolComp = Symbol('component');
  var SymbolJob = Symbol('job');
  var majorVersion = React.version ? Number.parseInt(React.version.slice(0, React.version.indexOf('.')), 10) : 0;
  function shallowEqual(o1, o2, excludes) {
    if (excludes === void 0) {
      excludes = [];
    }

    if (o1 === o2) {
      return true;
    }

    if (typeof o1 !== 'object' || typeof o2 !== 'object' || o1 === null || o2 === null) {
      return false;
    }

    if (Array.isArray(o1) && Array.isArray(o2)) {
      var len = o1.length;

      if (len !== o2.length) {
        return false;
      }

      for (var i = 0; i < len; ++i) {
        if (o1[i] !== o2[i]) {
          return false;
        }
      }

      return true;
    }

    var keys1 = Object.keys(o1);
    var keys2 = Object.keys(o2);

    if (keys1.length !== keys2.length) {
      return false;
    }

    for (var _i = 0; _i < keys1.length; ++_i) {
      var key = keys1[_i];

      if (!excludes.includes(key) && (!keys2.includes(key) || o1[key] !== o2[key])) {
        return false;
      }
    }

    return true;
  }

  var AsyncComponent =
  /*#__PURE__*/
  function (_React$PureComponent) {
    _inheritsLoose(AsyncComponent, _React$PureComponent);

    function AsyncComponent(props) {
      var _this;

      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      _this = _React$PureComponent.call.apply(_React$PureComponent, [this, props].concat(args)) || this;

      _this.setStateSafe = function (newState) {
        if (_this.mounted) {
          _this.setState(newState);
        } else {
          Object.assign(_this.state, newState);
        }
      };

      _this.updateProgress = function (propName) {
        return function (progress) {
          return _this.setState(function (preState) {
            var _objectSpread2;

            return {
              progress: _objectSpread({}, preState.progress, (_objectSpread2 = {}, _objectSpread2[propName] = progress, _objectSpread2))
            };
          });
        };
      };

      _this.loadSuccess = function (pairs) {
        var compPair = null;

        for (var i = 0; i < pairs.length; ++i) {
          var _pairs$i = pairs[i],
              k = _pairs$i[0];

          if (k === SymbolComp) {
            var _pairs$splice = pairs.splice(i, 1);

            compPair = _pairs$splice[0];
          }
        }

        var newState = {
          resolvedProps: fromPairs(pairs),
          progress: fromPairs(pairs.map(function (_ref) {
            var k = _ref[0];
            return [k, 1];
          })),
          error: null,
          loading: false
        };

        if (compPair) {
          var _compPair = compPair;
          newState.component = _compPair[1];
        }

        _this.setStateSafe(newState);
      };

      _this.state = {
        error: null,
        loading: true,
        resolvedProps: {},
        component: null,
        progress: fromPairs(Object.keys(props.asyncProps || {}).map(function (k) {
          return [k, 0];
        }))
      };
      return _this;
    }

    var _proto = AsyncComponent.prototype;

    _proto.componentDidMount = function componentDidMount() {
      this.mounted = true;
      this.load();
    };

    _proto.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      // noinspection JSUnresolvedFunction
      if (nextProps.reloader && nextProps.reloader.isReload()) {
        // noinspection JSUnresolvedFunction
        nextProps.reloader.resetReload();

        if (!this.state.loading) {
          this.load();
        }
      }

      if (nextProps.reloadOnUpdate && !this.state.loading) {
        if (nextProps.reloadDependents === null || nextProps.reloadDependents === undefined) {
          if (!shallowEqual(this.props, nextProps, ['batch', 'errorComponent', 'loadingComponent', 'onError', 'delay', 'reloadOnUpdate', 'reloadDependents', 'reloader'])) {
            this.load();
          }
        } else if (!shallowEqual(this.props.reloadDependents, nextProps.reloadDependents)) {
          this.load();
        }
      }
    };

    _proto.componentWillUnmount = function componentWillUnmount() {
      this.mounted = false;
    };

    _proto.load = function load() {
      var _this2 = this;

      var _this$props = this.props,
          asyncComponent = _this$props.asyncComponent,
          asyncJobs = _this$props.asyncJobs,
          asyncProps = _this$props.asyncProps,
          onError = _this$props.onError,
          delay = _this$props.delay;
      this.setStateSafe({
        error: null,
        loading: true,
        progress: fromPairs(Object.keys(asyncProps || {}).map(function (k) {
          return [k, 0];
        }))
      });

      try {
        var pairs = (asyncComponent ? [[SymbolComp, asyncComponent]] : []).concat((asyncJobs || []).map(function (job) {
          return [SymbolJob, job];
        }), toPairs(asyncProps || {})).filter(function (entry) {
          return entry[1];
        });

        if (some(pairs, function (entry) {
          return !isFunction(entry[1]);
        })) {
          var error = new Error('The async job or async prop must be a function.'); // noinspection JSCheckFunctionSignatures

          this.setState({
            error: error,
            loading: false
          });

          if (onError) {
            onError(error);
          }

          return;
        }

        var batch = this.props.batch;
        pairs = pairs.map(function (_ref2) {
          var k = _ref2[0],
              v = _ref2[1];
          return [k, v(typeof k !== 'symbol' ? _this2.updateProgress(k) : null)];
        });

        if (delay > 0) {
          pairs.push([SymbolJob, new Promise(function (resolve) {
            return setTimeout(resolve, delay);
          })]);
        }

        if (some(pairs, function (pair) {
          return _isPromise_2_1_0_isPromise(pair[1]);
        })) {
          var promises = pairs.map(function (_ref3) {
            var k = _ref3[0],
                p = _ref3[1];

            if (_isPromise_2_1_0_isPromise(p)) {
              return p.then(function (res) {
                if (!batch && typeof k !== 'symbol') {
                  if (_this2.mounted) {
                    var _AsyncComponent$updat;

                    _this2.setState(AsyncComponent.updateResolvedProps((_AsyncComponent$updat = {}, _AsyncComponent$updat[k] = res, _AsyncComponent$updat)));
                  } else {
                    _this2.state.resolvedProps[k] = res;
                    _this2.state.progress[k] = 1;
                  }
                }

                if (!batch && k === SymbolComp) {
                  _this2.setStateSafe({
                    component: res
                  });
                }

                return [k, res];
              });
            }

            if (!batch && typeof k !== 'symbol') {
              var _AsyncComponent$updat2;

              _this2.setState(AsyncComponent.updateResolvedProps((_AsyncComponent$updat2 = {}, _AsyncComponent$updat2[k] = p, _AsyncComponent$updat2)));
            }

            if (!batch && k === SymbolComp) {
              // noinspection JSCheckFunctionSignatures
              _this2.setState({
                component: p
              });
            }

            return [k, p];
          });
          Promise.all(promises).then(function (pairs) {
            _this2.loadSuccess(pairs.filter(function (_ref4) {
              var k = _ref4[0];
              return typeof k !== 'symbol';
            }));
          }).catch(function (e) {
            try {
              if (onError) {
                onError(e);
              }
            } finally {
              _this2.setStateSafe({
                error: e
              });
            }
          }).finally(function () {
            _this2.setStateSafe({
              loading: false
            });
          });
        } else {
          this.loadSuccess(pairs.filter(function (_ref5) {
            var k = _ref5[0];
            return typeof k !== 'symbol';
          }));
        }
      } catch (error) {
        try {
          if (onError) {
            onError(error);
          }
        } finally {
          this.setStateSafe({
            loading: false
          });
        }
      }
    };

    _proto.render = function render() {
      var _this$props2 = this.props,
          ErrorComponent = _this$props2.errorComponent,
          LoadingComponent = _this$props2.loadingComponent,
          asyncPropOpts = _this$props2.asyncPropOpts,
          asyncPropsMapper = _this$props2.asyncPropsMapper,
          asyncComponent = _this$props2.asyncComponent,
          children = _this$props2.children,
          unwrapDefault = _this$props2.unwrapDefault;
      var syncProps = this.props.syncProps;
      var Comp = this.props.component;
      var _this$state = this.state,
          error = _this$state.error,
          loading = _this$state.loading,
          resolvedProps = _this$state.resolvedProps,
          progress = _this$state.progress;
      var wrappedProps = asyncPropsMapper(Object.assign({}, mapValues(asyncPropOpts, function (opt) {
        return opt.defaultProp;
      }, function (opt) {
        return opt && {}.hasOwnProperty.call(opt, 'defaultProp');
      }), resolvedProps));
      var ref;

      if ({}.hasOwnProperty.call(syncProps, 'ref')) {
        var _syncProps = syncProps;
        ref = _syncProps.ref;
        syncProps = _objectWithoutProperties(_syncProps, ["ref"]);
      }

      if ({}.hasOwnProperty.call(wrappedProps, 'ref')) {
        var _wrappedProps = wrappedProps;
        ref = _wrappedProps.ref;
        wrappedProps = _objectWithoutProperties(_wrappedProps, ["ref"]);
      }

      var _wrappedProps2 = wrappedProps,
          ignored = _wrappedProps2.children,
          restResolvedProps = _objectWithoutPropertiesLoose(_wrappedProps2, ["children"]);

      if (loading && LoadingComponent !== DefaultLoadingComponent) {
        return React.createElement(LoadingComponent, _extends({}, this.props, restResolvedProps, {
          loading: loading,
          progress: progress
        }));
      }

      if (error) {
        return React.createElement(ErrorComponent, _extends({}, this.props, restResolvedProps, {
          loading: loading,
          progress: progress,
          error: error
        }));
      }

      if (asyncComponent) {
        if (this.state.component) {
          Comp = this.state.component;
        } else {
          return null;
        }
      }

      if (Comp) {
        if (unwrapDefault) {
          // eslint-disable-next-line no-underscore-dangle
          Comp = Comp.default || Comp;
        }

        return !isStateless(Comp) && ref ? React.createElement(Comp, _extends({}, syncProps || {}, wrappedProps, {
          ref: ref,
          loading: loading,
          progress: progress
        })) : React.createElement(Comp, _extends({}, syncProps || {}, wrappedProps, {
          loading: loading,
          progress: progress
        }));
      } // noinspection JSUnresolvedFunction JSCheckFunctionSignatures


      var newChildren = React.Children.map(children, function (child) {
        return React.cloneElement(child, _objectSpread({}, syncProps || {}, restResolvedProps, {
          loading: loading,
          progress: progress
        }));
      });

      if (!newChildren) {
        return null;
      }

      if (newChildren.length === 1) {
        return newChildren[0];
      } else if (newChildren.length > 1) {
        return majorVersion >= 16 ? newChildren : React.createElement("div", null, " ", newChildren, " ");
      }

      return null;
    };

    return AsyncComponent;
  }(React.PureComponent);

  AsyncComponent.updateResolvedProps = function (resolvedProps) {
    return function (preState) {
      return {
        resolvedProps: _objectSpread({}, preState.resolvedProps, resolvedProps),
        progress: _objectSpread({}, preState.progress, fromPairs(Object.keys(resolvedProps).map(function (k) {
          return [k, 1];
        })))
      };
    };
  };

  AsyncComponent.createReloader = function (compInst) {
    var forceReload = false;
    return {
      reload: function reload() {
        forceReload = true;
        compInst.setState({
          __reloader__3yPbia72w46: {}
        });
      },
      isReload: function isReload() {
        return forceReload;
      },
      resetReload: function resetReload() {
        forceReload = false;
      }
    };
  };

  var any = PropTypes.any,
      bool = PropTypes.bool,
      number = PropTypes.number,
      object = PropTypes.object,
      objectOf = PropTypes.objectOf,
      func = PropTypes.func,
      oneOfType = PropTypes.oneOfType,
      arrayOf = PropTypes.arrayOf,
      element = PropTypes.element,
      shape = PropTypes.shape;
  AsyncComponent.propTypes = {
    /** If true, only when all async props are resolved, the wrapped component is rendered again.
     Otherwise, the wrapped component will be updated when any async prop is resolved. */
    batch: bool,

    /** The async jobs.
     Compared to async props, they will not provide the props to the wrapped component,
     but they should be done before the wrapped component finally render.
     The word 'finally' means the wrapped component will be updated several time if 'batch' set to false. */
    asyncJobs: arrayOf(func),

    /** All async props should be declared here.They should be functions.
     If the function return a promise, it will be a real async prop,
     otherwise it is still a sync prop.
     The es6 async function is supported. In fact it is just a function return promise.
     The async component will provide every function with a method to update the progress
     which is a number range from 0 to 1. */
    asyncProps: objectOf(func),

    /** The option of the async props. At this moment, only 'defaultProp' is supported. */
    asyncPropOpts: objectOf(shape({
      defaultProp: any
    })),

    /** Accept the resolved async props, and return the props provide to the wrapped component. */
    asyncPropsMapper: func,

    /** The sync props.
     *  This is useful when providing component or asyncComponent prop
     *  instead of children node as wrapped component. */
    syncProps: objectOf(any),

    /** If specialized, the async wrapper will use this as the wrapped component
     *  instead of the children components. */
    component: oneOfType([func, object]),

    /** If specialized, the async wrapper will use this as the wrapped component
     *  when resolved instead of component prop and the children components. */
    asyncComponent: func,
    children: oneOfType([element, arrayOf(element)]),

    /** This component will be used to show the error. */
    errorComponent: oneOfType([func, object]),

    /** When the async jobs and async props have not been resolved yet, this component will be rendered.
     However, if this prop is not specialized,
     the wrapped component with default and partial resolved props will be rendered instead. */
    loadingComponent: oneOfType([func, object]),

    /** The error callback.
     It will be called when a error is throwed
     during the async jobs is running or the async props is resolved. */
    onError: func,

    /** A number greater than 0 will force the wrapped component rendering with a delay. */
    delay: number,

    /** Useful when provide the asyncComponent with dynamic import method.
     * The dynamic import method return a promise resolving a module object.
     * However, we often need the module.default instead of the module itself.
     * This option make the wrapper try to use module.default when available */
    unwrapDefault: bool,

    /**
     * Whether to reload the date when the AsyncComponent is updated.
     */
    reloadOnUpdate: bool,

    /**
     * The dependents which using to decide whether to reload. Shallow equal is used to compare changed.
     * Only valid when reloadOnUpdate is true.
     * If set null or undefined, means use all props to decide.
     */
    reloadDependents: objectOf(any),

    /**
     * An object create by `AsyncComponent.createReloader`,
     * The api `reloader.reload()` can be used to force a reload task.
     */
    reloader: shape({
      reload: func,
      isReload: func,
      resetReload: func
    })
  };
  AsyncComponent.defaultProps = {
    batch: false,
    asyncJobs: [],
    asyncProps: {},
    asyncPropOpts: {},
    asyncPropsMapper: function asyncPropsMapper(props) {
      return props;
    },
    syncProps: {},
    component: null,
    asyncComponent: null,
    children: null,
    errorComponent: DefaultErrorComponent,
    loadingComponent: DefaultLoadingComponent,
    onError: function onError() {
      return null;
    },
    delay: 0,
    unwrapDefault: true,
    reloadOnUpdate: false,
    reloadDependents: null,
    reloader: null
  };

  function unwrapExports (x) {
  	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x.default : x;
  }

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  var reactIs_production_min = createCommonjsModule(function (module, exports) {
  Object.defineProperty(exports,"__esModule",{value:!0});
  var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,r=b?Symbol.for("react.memo"):
  60115,t=b?Symbol.for("react.lazy"):60116;function u(a){if("object"===typeof a&&null!==a){var q=a.$$typeof;switch(q){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case h:return a;default:return q}}case d:return q}}}function v(a){return u(a)===m}exports.typeOf=u;exports.AsyncMode=l;exports.ConcurrentMode=m;exports.ContextConsumer=k;exports.ContextProvider=h;exports.Element=c;exports.ForwardRef=n;exports.Fragment=e;
  exports.Profiler=g;exports.Portal=d;exports.StrictMode=f;exports.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n)};exports.isAsyncMode=function(a){return v(a)||u(a)===l};exports.isConcurrentMode=v;exports.isContextConsumer=function(a){return u(a)===k};exports.isContextProvider=function(a){return u(a)===h};
  exports.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};exports.isForwardRef=function(a){return u(a)===n};exports.isFragment=function(a){return u(a)===e};exports.isProfiler=function(a){return u(a)===g};exports.isPortal=function(a){return u(a)===d};exports.isStrictMode=function(a){return u(a)===f};
  });

  unwrapExports(reactIs_production_min);
  var reactIs_production_min_1 = reactIs_production_min.typeOf;
  var reactIs_production_min_2 = reactIs_production_min.AsyncMode;
  var reactIs_production_min_3 = reactIs_production_min.ConcurrentMode;
  var reactIs_production_min_4 = reactIs_production_min.ContextConsumer;
  var reactIs_production_min_5 = reactIs_production_min.ContextProvider;
  var reactIs_production_min_6 = reactIs_production_min.Element;
  var reactIs_production_min_7 = reactIs_production_min.ForwardRef;
  var reactIs_production_min_8 = reactIs_production_min.Fragment;
  var reactIs_production_min_9 = reactIs_production_min.Profiler;
  var reactIs_production_min_10 = reactIs_production_min.Portal;
  var reactIs_production_min_11 = reactIs_production_min.StrictMode;
  var reactIs_production_min_12 = reactIs_production_min.isValidElementType;
  var reactIs_production_min_13 = reactIs_production_min.isAsyncMode;
  var reactIs_production_min_14 = reactIs_production_min.isConcurrentMode;
  var reactIs_production_min_15 = reactIs_production_min.isContextConsumer;
  var reactIs_production_min_16 = reactIs_production_min.isContextProvider;
  var reactIs_production_min_17 = reactIs_production_min.isElement;
  var reactIs_production_min_18 = reactIs_production_min.isForwardRef;
  var reactIs_production_min_19 = reactIs_production_min.isFragment;
  var reactIs_production_min_20 = reactIs_production_min.isProfiler;
  var reactIs_production_min_21 = reactIs_production_min.isPortal;
  var reactIs_production_min_22 = reactIs_production_min.isStrictMode;

  var reactIs_development = createCommonjsModule(function (module, exports) {



  {
    (function() {

  Object.defineProperty(exports, '__esModule', { value: true });

  // The Symbol used to tag the ReactElement-like types. If there is no native Symbol
  // nor polyfill, then a plain number is used for performance.
  var hasSymbol = typeof Symbol === 'function' && Symbol.for;

  var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
  var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
  var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
  var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
  var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
  var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
  var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace;
  var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
  var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
  var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
  var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
  var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
  var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;

  function isValidElementType(type) {
    return typeof type === 'string' || typeof type === 'function' ||
    // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
    type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE);
  }

  /**
   * Forked from fbjs/warning:
   * https://github.com/facebook/fbjs/blob/e66ba20ad5be433eb54423f2b097d829324d9de6/packages/fbjs/src/__forks__/warning.js
   *
   * Only change is we use console.warn instead of console.error,
   * and do nothing when 'console' is not supported.
   * This really simplifies the code.
   * ---
   * Similar to invariant but only logs a warning if the condition is not met.
   * This can be used to log issues in development environments in critical
   * paths. Removing the logging code for production environments will keep the
   * same logic and follow the same code paths.
   */

  var lowPriorityWarning = function () {};

  {
    var printWarning = function (format) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var argIndex = 0;
      var message = 'Warning: ' + format.replace(/%s/g, function () {
        return args[argIndex++];
      });
      if (typeof console !== 'undefined') {
        console.warn(message);
      }
      try {
        // --- Welcome to debugging React ---
        // This error was thrown as a convenience so that you can use this stack
        // to find the callsite that caused this warning to fire.
        throw new Error(message);
      } catch (x) {}
    };

    lowPriorityWarning = function (condition, format) {
      if (format === undefined) {
        throw new Error('`lowPriorityWarning(condition, format, ...args)` requires a warning ' + 'message argument');
      }
      if (!condition) {
        for (var _len2 = arguments.length, args = Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
          args[_key2 - 2] = arguments[_key2];
        }

        printWarning.apply(undefined, [format].concat(args));
      }
    };
  }

  var lowPriorityWarning$1 = lowPriorityWarning;

  function typeOf(object) {
    if (typeof object === 'object' && object !== null) {
      var $$typeof = object.$$typeof;

      switch ($$typeof) {
        case REACT_ELEMENT_TYPE:
          var type = object.type;

          switch (type) {
            case REACT_ASYNC_MODE_TYPE:
            case REACT_CONCURRENT_MODE_TYPE:
            case REACT_FRAGMENT_TYPE:
            case REACT_PROFILER_TYPE:
            case REACT_STRICT_MODE_TYPE:
              return type;
            default:
              var $$typeofType = type && type.$$typeof;

              switch ($$typeofType) {
                case REACT_CONTEXT_TYPE:
                case REACT_FORWARD_REF_TYPE:
                case REACT_PROVIDER_TYPE:
                  return $$typeofType;
                default:
                  return $$typeof;
              }
          }
        case REACT_PORTAL_TYPE:
          return $$typeof;
      }
    }

    return undefined;
  }

  // AsyncMode is deprecated along with isAsyncMode
  var AsyncMode = REACT_ASYNC_MODE_TYPE;
  var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
  var ContextConsumer = REACT_CONTEXT_TYPE;
  var ContextProvider = REACT_PROVIDER_TYPE;
  var Element = REACT_ELEMENT_TYPE;
  var ForwardRef = REACT_FORWARD_REF_TYPE;
  var Fragment = REACT_FRAGMENT_TYPE;
  var Profiler = REACT_PROFILER_TYPE;
  var Portal = REACT_PORTAL_TYPE;
  var StrictMode = REACT_STRICT_MODE_TYPE;

  var hasWarnedAboutDeprecatedIsAsyncMode = false;

  // AsyncMode should be deprecated
  function isAsyncMode(object) {
    {
      if (!hasWarnedAboutDeprecatedIsAsyncMode) {
        hasWarnedAboutDeprecatedIsAsyncMode = true;
        lowPriorityWarning$1(false, 'The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
      }
    }
    return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
  }
  function isConcurrentMode(object) {
    return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
  }
  function isContextConsumer(object) {
    return typeOf(object) === REACT_CONTEXT_TYPE;
  }
  function isContextProvider(object) {
    return typeOf(object) === REACT_PROVIDER_TYPE;
  }
  function isElement(object) {
    return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
  }
  function isForwardRef(object) {
    return typeOf(object) === REACT_FORWARD_REF_TYPE;
  }
  function isFragment(object) {
    return typeOf(object) === REACT_FRAGMENT_TYPE;
  }
  function isProfiler(object) {
    return typeOf(object) === REACT_PROFILER_TYPE;
  }
  function isPortal(object) {
    return typeOf(object) === REACT_PORTAL_TYPE;
  }
  function isStrictMode(object) {
    return typeOf(object) === REACT_STRICT_MODE_TYPE;
  }

  exports.typeOf = typeOf;
  exports.AsyncMode = AsyncMode;
  exports.ConcurrentMode = ConcurrentMode;
  exports.ContextConsumer = ContextConsumer;
  exports.ContextProvider = ContextProvider;
  exports.Element = Element;
  exports.ForwardRef = ForwardRef;
  exports.Fragment = Fragment;
  exports.Profiler = Profiler;
  exports.Portal = Portal;
  exports.StrictMode = StrictMode;
  exports.isValidElementType = isValidElementType;
  exports.isAsyncMode = isAsyncMode;
  exports.isConcurrentMode = isConcurrentMode;
  exports.isContextConsumer = isContextConsumer;
  exports.isContextProvider = isContextProvider;
  exports.isElement = isElement;
  exports.isForwardRef = isForwardRef;
  exports.isFragment = isFragment;
  exports.isProfiler = isProfiler;
  exports.isPortal = isPortal;
  exports.isStrictMode = isStrictMode;
    })();
  }
  });

  unwrapExports(reactIs_development);
  var reactIs_development_1 = reactIs_development.typeOf;
  var reactIs_development_2 = reactIs_development.AsyncMode;
  var reactIs_development_3 = reactIs_development.ConcurrentMode;
  var reactIs_development_4 = reactIs_development.ContextConsumer;
  var reactIs_development_5 = reactIs_development.ContextProvider;
  var reactIs_development_6 = reactIs_development.Element;
  var reactIs_development_7 = reactIs_development.ForwardRef;
  var reactIs_development_8 = reactIs_development.Fragment;
  var reactIs_development_9 = reactIs_development.Profiler;
  var reactIs_development_10 = reactIs_development.Portal;
  var reactIs_development_11 = reactIs_development.StrictMode;
  var reactIs_development_12 = reactIs_development.isValidElementType;
  var reactIs_development_13 = reactIs_development.isAsyncMode;
  var reactIs_development_14 = reactIs_development.isConcurrentMode;
  var reactIs_development_15 = reactIs_development.isContextConsumer;
  var reactIs_development_16 = reactIs_development.isContextProvider;
  var reactIs_development_17 = reactIs_development.isElement;
  var reactIs_development_18 = reactIs_development.isForwardRef;
  var reactIs_development_19 = reactIs_development.isFragment;
  var reactIs_development_20 = reactIs_development.isProfiler;
  var reactIs_development_21 = reactIs_development.isPortal;
  var reactIs_development_22 = reactIs_development.isStrictMode;

  var _reactIs_16_6_3_reactIs = createCommonjsModule(function (module) {

  {
    module.exports = reactIs_development;
  }
  });

  /**
   * Copyright 2015, Yahoo! Inc.
   * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
   */


  var REACT_STATICS = {
      childContextTypes: true,
      contextType: true,
      contextTypes: true,
      defaultProps: true,
      displayName: true,
      getDefaultProps: true,
      getDerivedStateFromProps: true,
      mixins: true,
      propTypes: true,
      type: true
  };

  var KNOWN_STATICS = {
      name: true,
      length: true,
      prototype: true,
      caller: true,
      callee: true,
      arguments: true,
      arity: true
  };

  var FORWARD_REF_STATICS = {
      '$$typeof': true,
      render: true
  };

  var TYPE_STATICS = {};
  TYPE_STATICS[_reactIs_16_6_3_reactIs.ForwardRef] = FORWARD_REF_STATICS;

  var defineProperty = Object.defineProperty;
  var getOwnPropertyNames = Object.getOwnPropertyNames;
  var getOwnPropertySymbols = Object.getOwnPropertySymbols;
  var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
  var getPrototypeOf = Object.getPrototypeOf;
  var objectPrototype = Object.prototype;

  function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
      if (typeof sourceComponent !== 'string') {
          // don't hoist over string (html) components

          if (objectPrototype) {
              var inheritedComponent = getPrototypeOf(sourceComponent);
              if (inheritedComponent && inheritedComponent !== objectPrototype) {
                  hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
              }
          }

          var keys = getOwnPropertyNames(sourceComponent);

          if (getOwnPropertySymbols) {
              keys = keys.concat(getOwnPropertySymbols(sourceComponent));
          }

          var targetStatics = TYPE_STATICS[targetComponent['$$typeof']] || REACT_STATICS;
          var sourceStatics = TYPE_STATICS[sourceComponent['$$typeof']] || REACT_STATICS;

          for (var i = 0; i < keys.length; ++i) {
              var key = keys[i];
              if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
                  var descriptor = getOwnPropertyDescriptor(sourceComponent, key);
                  try {
                      // Avoid failures from read-only properties
                      defineProperty(targetComponent, key, descriptor);
                  } catch (e) {}
              }
          }

          return targetComponent;
      }

      return targetComponent;
  }

  var hoistNonReactStatics_cjs = hoistNonReactStatics;

  var makeAsync = (function (opts) {
    if (opts === void 0) {
      opts = {};
    }

    return function (Comp) {
      var _opts = opts,
          _opts$batch = _opts.batch,
          batch = _opts$batch === void 0 ? false : _opts$batch,
          _opts$asyncJobs = _opts.asyncJobs,
          asyncJobs = _opts$asyncJobs === void 0 ? [] : _opts$asyncJobs,
          _opts$asyncProps = _opts.asyncProps,
          asyncProps = _opts$asyncProps === void 0 ? {} : _opts$asyncProps,
          _opts$asyncPropOpts = _opts.asyncPropOpts,
          asyncPropOpts = _opts$asyncPropOpts === void 0 ? {} : _opts$asyncPropOpts,
          _opts$asyncPropsMappe = _opts.asyncPropsMapper,
          asyncPropsMapper = _opts$asyncPropsMappe === void 0 ? function (props) {
        return props;
      } : _opts$asyncPropsMappe,
          _opts$errorComponent = _opts.errorComponent,
          errorComponent = _opts$errorComponent === void 0 ? DefaultErrorComponent : _opts$errorComponent,
          _opts$loadingComponen = _opts.loadingComponent,
          loadingComponent = _opts$loadingComponen === void 0 ? DefaultLoadingComponent : _opts$loadingComponen,
          _opts$onError = _opts.onError,
          onError = _opts$onError === void 0 ? function () {
        return null;
      } : _opts$onError,
          _opts$delay = _opts.delay,
          delay = _opts$delay === void 0 ? 0 : _opts$delay,
          _opts$unwrapDefault = _opts.unwrapDefault,
          unwrapDefault = _opts$unwrapDefault === void 0 ? true : _opts$unwrapDefault,
          _opts$reloadOnUpdate = _opts.reloadOnUpdate,
          reloadOnUpdate = _opts$reloadOnUpdate === void 0 ? false : _opts$reloadOnUpdate,
          _opts$reloadDependent = _opts.reloadDependents,
          reloadDependents = _opts$reloadDependent === void 0 ? null : _opts$reloadDependent; // eslint-disable-next-line

      var C =
      /*#__PURE__*/
      function (_React$Component) {
        _inheritsLoose(C, _React$Component);

        function C() {
          return _React$Component.apply(this, arguments) || this;
        }

        var _proto = C.prototype;

        _proto.render = function render() {
          var _this$props = this.props,
              wrappedComponentRef = _this$props.wrappedComponentRef,
              remainingProps = _objectWithoutPropertiesLoose(_this$props, ["wrappedComponentRef"]);

          var wrapperProps = {
            batch: batch,
            asyncJobs: asyncJobs,
            asyncProps: asyncProps,
            asyncPropOpts: asyncPropOpts,
            asyncPropsMapper: asyncPropsMapper,
            errorComponent: errorComponent,
            loadingComponent: loadingComponent,
            onError: onError,
            delay: delay,
            unwrapDefault: unwrapDefault,
            reloadOnUpdate: reloadOnUpdate,
            reloadDependents: reloadDependents,
            syncProps: _objectSpread({}, remainingProps, {
              ref: wrappedComponentRef
            })
          };

          if (_isPromise_2_1_0_isPromise(Comp)) {
            wrapperProps.asyncComponent = function () {
              return Comp;
            };
          } else {
            wrapperProps.component = Comp;
          }

          return React.createElement(AsyncComponent, wrapperProps);
        };

        return C;
      }(React.Component);

      C.displayName = "makeAsync(" + (!_isPromise_2_1_0_isPromise(Comp) ? Comp.displayName || Comp.name : 'Unknown') + ")";
      C.propTypes = {
        // eslint-disable-next-line
        wrappedComponentRef: PropTypes.func
      };
      return _isPromise_2_1_0_isPromise(Comp) ? C : hoistNonReactStatics_cjs(C, Comp);
    };
  });

  exports.AsyncComponent = AsyncComponent;
  exports.makeAsync = makeAsync;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=index.js.map
